#include "at32f403a_407.h"
#include "log_dio.h"
#include "settings_api.h"



#if defined (MDIO_88)


#undef DBG
#define DBG if(1)


// Архив. 8 буферов на каждый канал.
void log_dio_archive_init(void)
{
    for (uint8_t i = 0; i < ARCH_DIO_CH_NUMBER; i ++) 
    {
        fingfs_flash_ch_arch[i].sector_size = spi_flash_desc.sector_size,
        
        fingfs_flash_ch_arch[i].sector_count = ARCHIVE_FLASH_SECTOR_COUNT,
        
        ringfs_init(&fs_ch_arch[i], &fingfs_flash_ch_arch[i], 
                    ARCHIV_ENTRY_VERSION + i, sizeof(archive_entry_t));
        
        if (ringfs_scan(&fs_ch_arch[i]) != 0) {
            DBG printf("FAT for channel %u is false\r\n", i + 1);
            ringfs_format(&fs_ch_arch[i]);
        }
        DBG printf("FAT for channel %u is true\r\n", i + 1);
    }
}
    
    

#endif

